//
//  JSSDataView.m
//  Pintoresco
//
//  Created by jsainz on 16/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);

#import "JSSDataView.h"

@interface JSSDataView ()

@end

@implementation JSSDataView

@synthesize fromMain;
@synthesize fromInfo;
@synthesize name;
@synthesize dataUser;
@synthesize dataInfoUser;
@synthesize identifier;
@synthesize collectedData;
@synthesize summary;

#pragma mark - Life cycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = @"DATOS";
    }
    // Initializes the array which contains data collected from the subject
    dataInfoUser = [[NSMutableArray alloc]init];
    for (NSInteger i=0; i<13; i++)
        [dataInfoUser addObject:@""];
    return self;
}

- (void)collectData {
    for (NSInteger i=1; i<dataUser.count; i++)
        [collectedData addObject:[dataUser objectAtIndex:i]];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // [self.navigationItem setTitle:@"DATOS"];
    self.view.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1]; //FFDEAD
    
    // [self printOutData]; // Activate for printing out current data array
    
    [self setNavigationBar];
    [self cardLabels];
    [self cardData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)setNavigationBar {
    NSString *nameStr = [[NSString alloc]init];
    nameStr = @"BASES";
    JSSUtils *bin = [[JSSUtils alloc]init];
    UIButton *button = [[UIButton alloc]init];
    button = [bin setNavigationBar:nameStr];
    [button addTarget:self action:@selector(BtnBackClick:) forControlEvents:UIControlEventTouchUpInside];
    
    //creates a UIBarButtonItem with the button as a custom view
    UIBarButtonItem *backButton = [[UIBarButtonItem alloc]initWithCustomView:button];
    // [backButton setBackButtonTitlePositionAdjustment:UIOffsetMake(0.0, 0.0) forBarMetrics:UIBarMetricsDefault];
    [[self navigationItem]setLeftBarButtonItem:backButton];
    self.navigationItem.hidesBackButton = YES;
}

#pragma mark - Methods for printing out subject data

- (void) printOutData {
    if (!(fromMain == nil)) {
        NSLog(@"Received message: %@", fromMain);
        
        JSSMainView *mainView = [[JSSMainView alloc]init];
        NSString *datum = [[NSString alloc]init];
        NSMutableString *label = [[NSMutableString alloc]init];
        JSSUtils *bin = [[JSSUtils alloc] init];
        for (NSInteger i=1; i<dataUser.count; i++) {
            label = [mainView doLabel:i];
            label = [bin stringPadding:label length:25 string:@" "];
            datum = [dataUser objectAtIndex:i];
            NSLog(@"%@ %@", label, datum);
        }
        NSLog(@"-----------------------------------");
    }
}

#pragma mark - Methods for moving forward and back to a View Controller

- (IBAction)BtnBackClick:(id)sender {
    JSSMainView *mainView = [[JSSMainView alloc]init];
    [self.navigationController pushViewController:mainView animated:YES];
}

- (IBAction)doInfo:(id)sender {
    JSSInfoView *infoView = [[JSSInfoView alloc]init];
    [self.navigationController pushViewController:infoView animated:YES];
    
    infoView.fromData = @"Transferred Array";
    infoView.infoUser = dataInfoUser;
    
    for (NSInteger i=1; i<dataInfoUser.count; i++)
        [summary addObject:[dataInfoUser objectAtIndex:i]];
    infoView.summary = summary;
}

#pragma mark - Methods for creating and controlling Text Fields

- (NSMutableString*)doLabel:(int)i {
    NSMutableString *label = [[NSMutableString alloc]init];
    switch (i) {
        case 1:
            label = [NSMutableString stringWithFormat:@"Carné/Pasaporte : "];
            break;
        case 2:
            label = [NSMutableString stringWithFormat:@"Nombre : "];
            break;
        case 3:
            label = [NSMutableString stringWithFormat:@"Apellidos : "];
            break;
        case 4:
            label = [NSMutableString stringWithFormat:@"Fecha de Nacimiento : "];
            break;
        case 5:
            label = [NSMutableString stringWithFormat:@"Ciudad/Provincia : "];
            break;
        case 6:
            label = [NSMutableString stringWithFormat:@"eCorreo : "];
            break;
        case 7:
            label = [NSMutableString stringWithFormat:@"Dirección : "];
            break;
        case 8:
            label = [NSMutableString stringWithFormat:@"Ciudad : " ];
            break;
        case 9:
            label = [NSMutableString stringWithFormat:@"Código Postal : "];
            break;
        case 10:
            label = [NSMutableString stringWithFormat:@"Provincia/Estado : "];
            break;
        case 11:
            label = [NSMutableString stringWithFormat:@"Teléfono Fijo : "];
            break;
        default:
            label = [NSMutableString stringWithFormat:@"Teléfono Móvil : "];
            break;
    } //
    return label;
}

- (void)cardLabels {
    
    float height = ([[UIScreen mainScreen] bounds].size.height);
    float width = ([[UIScreen mainScreen] bounds].size.width);

    CGRect fstFrame = CGRectMake(width/15, height/9, 210.0f, 30.0f);
    CGRect sndFrame = CGRectMake(width/15, height/2.5, 210.0f, 30.0f);
    
    for (NSInteger i=1; i<13; i++) {
        switch (i) {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6: // Collects identity data
                fstFrame.origin.y += fstFrame.size.height + 10.0f;
                self.name = [[UILabel alloc] initWithFrame:fstFrame];
                break;
            default: // Collects address data
                sndFrame.origin.y += sndFrame.size.height + 10.0f;
                self.name = [[UILabel alloc] initWithFrame:sndFrame];
                break;
        }
        
        self.name.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0f];
        self.name.textAlignment =  NSTextAlignmentRight;
        [self.view addSubview:self.name];
        
        self.name.text = [self doLabel:i];
        
    } //  for (NSInteger i=1; i<13; i++)
} // (void)identityCardLabels

- (void)cardData {

    float height = ([[UIScreen mainScreen] bounds].size.height);
    float width = ([[UIScreen mainScreen] bounds].size.width);
    
    // Creates a label to display current user interaction with our editable text views
    CGRect fstFrame = CGRectMake(width/2.5, height/9, 400, 30.0f);
    CGRect sndFrame = CGRectMake(width/2.5, height/2.5, 400, 30.0f);
    self.name = [[UILabel alloc] initWithFrame:fstFrame];
    self.name.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0f];
    self.name.text = @"Introduce tus datos";
    self.name.textAlignment =  NSTextAlignmentCenter;
    [self.view addSubview:self.name];

    for (NSInteger i=1; i<13; i++) { // Creates the text field with that frame
        UITextField *textField = [[UITextField alloc]init];
        
        switch (i) {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
                fstFrame.origin.y += fstFrame.size.height + 10.0f;
                textField = [[UITextField alloc] initWithFrame:fstFrame];
                break;
            default:
                sndFrame.origin.y += sndFrame.size.height + 10.0f;
                textField = [[UITextField alloc] initWithFrame:sndFrame];
                break;
        }
        textField.borderStyle = UITextBorderStyleRoundedRect;
        textField.textAlignment = NSTextAlignmentCenter;

        switch (i) {
            case 1:
            case 4:
                textField.keyboardType = UIKeyboardTypeDecimalPad;
                break;
            case 6:
                textField.keyboardType = UIKeyboardTypeEmailAddress;
                break;
            case 9:
            case 11:
            case 12:
                textField.keyboardType = UIKeyboardTypeDecimalPad;
                break;
            default:
                textField.keyboardType = UIKeyboardTypeDefault;
                break;
        }
        // Displays hint for the user data entry when the field is empty
        
        NSString *textString = [[NSString alloc]init];
        textString = [self doLabel:i];
        
        textField.placeholder = [NSString stringWithFormat:@"Introduce datos de %@", textString];
        
        // Add tag to identify your text views
        textField.tag = i;
        // Displays the clear button on the text field
        textField.clearButtonMode = UITextFieldViewModeAlways;
        // Changes the return key text to "Done"
        textField.returnKeyType = UIReturnKeyDone;
        // Sets the delegate for the text field to the view controller
        // so that it can listen for events
        textField.delegate = self;
        // Adds the text field to the current view
        [self.view addSubview:textField];
    }
}

// Asks the delegate if editing should begin in the specified text field.
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField {
    return YES;
}

// Tells the delegate that editing began for the specified text field.
- (void)textFieldDidBeginEditing:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSString *textString = [[NSString alloc]init];
    textString = [self doLabel:i];
    self.name.text = [NSString stringWithFormat:@"Escritura de %@", textString];
}

// Asks the delegate if editing should stop in the specified text field.
- (BOOL)textFieldShouldEndEditing:(UITextField *)textField{
    return YES;
}

// Tells the delegate that editing stopped for the specified text field.
- (void)textFieldDidEndEditing:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSMutableString *textString = [[NSMutableString alloc]init];
    textString = [self doLabel:i];
    self.name.text = [NSString stringWithFormat:@"Datos de %@", textString];

    // NSLog(@"Registering... %i %@", i, textField.text);
    [dataInfoUser replaceObjectAtIndex:i withObject:textField.text];
}

// Asks the delegate if the specified text should be changed.
- (BOOL)textField:(UITextField *)textField
    shouldChangeCharactersInRange:(NSRange)range
    replacementString:(NSString *)string {
    
    //get the current data strsing inside the text field
    NSString *textData = [textField.text stringByReplacingCharactersInRange:range
                                                                   withString:string];
    // NSLog(@"El dato actual del texto es: %@", myTextData);
    NSCharacterSet * set = [[NSCharacterSet characterSetWithCharactersInString:@"0123456789./"] invertedSet];
    
    NSInteger i = textField.tag;
    switch (i) {
        case 1: //field should only have numeric data otherwise don't allow change
            if ([string rangeOfCharacterFromSet:set].location != NSNotFound)
                return NO;
            break;
        case 2:
        case 3:
            if ([textData length] > 25)
                return NO;
            break;
        case 4:
            if ([string rangeOfCharacterFromSet:set].location != NSNotFound)
                return NO;
            break;
        case 5:
        case 6:
        case 7:
        case 8:
            if ([textData length] > 25)
                return NO;
            break;
        case 9:
            if ([string rangeOfCharacterFromSet:set].location != NSNotFound)
                return NO;
            break;
        case 10:
            if ([textData length] > 25)
                return NO;
            break;
        case 11:
            if ([string rangeOfCharacterFromSet:set].location != NSNotFound)
                return NO;
            break;
        default:
            if ([string rangeOfCharacterFromSet:set].location != NSNotFound)
                return NO;
            break;
    }
    // set the display label value with the current data in the text field
    // self.name.text = [NSString stringWithFormat:@"Datos: %@", textData];
    return YES;
}

// Asks the delegate if the text field’s current contents should be removed.
- (BOOL)textFieldShouldClear:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSLog(@"Borrado de datos de %i", i);
    return YES;
}

// Asks the delegate if the text field should process the pressing of the return button.
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    //Notifies the receiver that it has been asked to relinquish its status as first responder
    [textField resignFirstResponder];
    return YES;
}

@end
