//
//  JSSInfoView.m
//  Pintoresco
//
//  Created by jsainz on 13/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#import "JSSInfoView.h"

@interface JSSInfoView ()

@property (strong, nonatomic) IBOutlet UIImageView *image;
@property (strong, nonatomic) UIPopoverController *popover;

- (IBAction)takePicture:(id)sender;

@end

@implementation JSSInfoView

@synthesize name;
@synthesize fromData;
@synthesize fromTable;
@synthesize infoUser;
@synthesize infoInfoUser;
@synthesize summary;

#pragma mark - Life cycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = @"INFORMACION";
    }
    // Initializes the array which contains data collected from the subject
    infoInfoUser = [[NSMutableArray alloc]init];
    for (NSInteger i=0; i<10; i++) {
        [infoInfoUser addObject:@""];
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1]; //FFDEAD
    
    // [self printOutData]; // Activate for printing out current data array
    [self setNavigationBar];
    [self cardData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)setNavigationBar {
    NSString *nameStr = [[NSString alloc]init];
    nameStr = @"DATOS";
    JSSUtils *bin = [[JSSUtils alloc]init];
    UIButton *button = [[UIButton alloc]init];
    button = [bin setNavigationBar:nameStr];
    [button addTarget:self action:@selector(BtnBackClick:) forControlEvents:UIControlEventTouchUpInside];
    
    //creates a UIBarButtonItem with the button as a custom view
    UIBarButtonItem *backButton = [[UIBarButtonItem alloc]initWithCustomView:button];
    [backButton setBackButtonTitlePositionAdjustment:UIOffsetMake(0.0, 0.0) forBarMetrics:UIBarMetricsDefault];
    [[self navigationItem]setLeftBarButtonItem:backButton];
    self.navigationItem.hidesBackButton = YES;
}

#pragma mark - Methods for printing out subject data

- (void)printOutData {
    if (!(fromData == nil)) {
        NSLog(@"Received message: %@", fromData);
        
        JSSDataView *dataView = [[JSSDataView alloc]init];
        NSString *datum = [[NSString alloc]init];
        NSMutableString *label = [[NSMutableString alloc]init];
        JSSUtils *bin = [[JSSUtils alloc] init];
        for (NSInteger i=1; i<infoUser.count; i++) {
            label = [dataView doLabel:i];
            label = [bin stringPadding:label length:25 string:@" "];
            datum = [infoUser objectAtIndex:i];
            NSLog(@"%@ %@", label, datum);
        }
        NSLog(@"-----------------------------------");
    }
}

#pragma mark - Methods for moving back and forward to a View Controller

- (IBAction)BtnBackClick:(id)sender {
    JSSDataView *dataView = [[JSSDataView alloc]init];
    [self.navigationController pushViewController:dataView animated:YES];
}

- (IBAction)setCriteria:(id)sender {
    JSSTableView *tableView = [[JSSTableView alloc]init];
    [self.navigationController pushViewController:tableView animated:YES];
    
    tableView.fromInfo = @"Transferred Array";
    tableView.tableUser = infoInfoUser;
    
    for (NSInteger i=1; i<infoInfoUser.count; i++)
        [summary addObject:[infoInfoUser objectAtIndex:i]];
    tableView.summary = summary;
}

#pragma mark - Methods for creating and controlling Text Fields

- (NSMutableString*)doLabel:(int)i {
    NSMutableString *label = [[NSMutableString alloc]init];
    switch (i) {
        case 1:
            label = [NSMutableString stringWithFormat:@"Titulación : "];
            break;
        case 2:
            label = [NSMutableString stringWithFormat:@"Curso : "];
            break;
        case 3:
            label = [NSMutableString stringWithFormat:@"Centro : "];
            break;
        case 4:
            label = [NSMutableString stringWithFormat:@"Dirección : "];
            break;
        case 5:
            label = [NSMutableString stringWithFormat:@"Ciudad : "];
            break;
        case 6:
            label = [NSMutableString stringWithFormat:@"Provincia/Estado : "];
            break;
        case 7:
            label = [NSMutableString stringWithFormat:@"Especialidad/Categoría : "];
            break;
        case 8:
            label = [NSMutableString stringWithFormat:@"Dirección : " ];
            break;
        default:
            label = [NSMutableString stringWithFormat:@"Ciudad : "];
            break;
    } //
    return label;
}

- (void)cardData {
    
    float height = ([[UIScreen mainScreen] bounds].size.height);
    float width = ([[UIScreen mainScreen] bounds].size.width);
    
    // Creates a label to display current user interaction with our editable text views
    CGRect fstFrame = CGRectMake(width/3, height/9, 400, 30.0f);
    CGRect sndFrame = CGRectMake(width/2.5, height/3.5, 400, 30.0f);
    CGRect trdFrame = CGRectMake(width/2.5, height/2.1, 400, 30.0f);
    
    self.name = [[UILabel alloc] initWithFrame:fstFrame];
    self.name.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0f];
    self.name.text = @"Introduce tus datos";
    self.name.textAlignment =  NSTextAlignmentCenter;
    [self.view addSubview:self.name];
    
    fstFrame = CGRectMake(width/1.9, height/9, 300, 30.0f);
    
    for (NSInteger i=1; i<10; i++) { // Creates the text field with that frame
        UITextField *textField = [[UITextField alloc]init];
        
        switch (i) {
            case 1:
            case 2:
            case 3:
                fstFrame.origin.y += fstFrame.size.height + 20.0f;
                textField = [[UITextField alloc] initWithFrame:fstFrame];
                break;
            case 4:
            case 5:
            case 6:
                sndFrame.origin.y += sndFrame.size.height + 20.0f;
                textField = [[UITextField alloc] initWithFrame:sndFrame];
                break;
            default:
                trdFrame.origin.y += trdFrame.size.height + 20.0f;
                textField = [[UITextField alloc] initWithFrame:trdFrame];
                break;
        }
        textField.borderStyle = UITextBorderStyleRoundedRect;
        textField.textAlignment = NSTextAlignmentCenter;
        
        switch (i) {
            default:
                textField.keyboardType = UIKeyboardTypeDefault;
                break;
        }
        // Displays hint for the user data entry when the field is empty
        NSString *textString = [[NSString alloc]init];
        textString = [self doLabel:i];
        
        textField.placeholder = [NSString stringWithFormat:@"Introduce datos de %@", textString];
        
        // Add tag to identify your text views
        textField.tag = i;
        // Displays the clear button on the text field
        textField.clearButtonMode = UITextFieldViewModeAlways;
        // Changes the return key text to "Done"
        textField.returnKeyType = UIReturnKeyDone;
        // Sets the delegate for the text field to the view controller
        // so that it can listen for events
        textField.delegate = self;
        // Adds the text field to the current view
        [self.view addSubview:textField];
    }
}

//Asks the delegate if editing should begin in the specified text field.
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField {
    return YES;
}

//Tells the delegate that editing began for the specified text field.
- (void)textFieldDidBeginEditing:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSString *textString = [[NSString alloc]init];
    textString = [self doLabel:i];
    self.name.text = [NSString stringWithFormat:@"Escritura de %@", textString];
}

//Asks the delegate if editing should stop in the specified text field.
- (BOOL)textFieldShouldEndEditing:(UITextField *)textField{
    return YES;
}

//Tells the delegate that editing stopped for the specified text field.
- (void)textFieldDidEndEditing:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSMutableString *textString = [[NSMutableString alloc]init];
    textString = [self doLabel:i];
    self.name.text = [NSString stringWithFormat:@"Datos de %@", textString];
    
    // NSLog(@"Registering... %i %@", i, textField.text);
    [infoInfoUser replaceObjectAtIndex:i withObject:textField.text];
}

//Asks the delegate if the specified text should be changed.
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range
    replacementString:(NSString *)string {
    
    //get the current data strsing inside the text field
    NSString *textData = [textField.text stringByReplacingCharactersInRange:range
                                                                   withString:string];
    NSInteger i = textField.tag;
    switch (i) {
        default: //don't allow more than a given number of characters
            if ([textData length] > 30)
                return NO;
            break;
    }
    // set the display label value with the current data in the text field
    // self.name.text = [NSString stringWithFormat:@"Datos: %@", textData];
    return YES;
}

//Asks the delegate if the text field’s current contents should be removed.
- (BOOL)textFieldShouldClear:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSLog(@"Borrado de datos de %i", i);
    return YES;
}

//Asks the delegate if the text field should process the pressing of the return button.
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    //Notifies the receiver that it has been asked to relinquish its status as first responder
    [textField resignFirstResponder];
    return YES;
}

#pragma mark - Methods for UIImagePickerControllerDelegate

- (void)navigationController:(UINavigationController *)navigationController willShowViewController:(UIViewController *)viewController animated:(BOOL)animated {
    
    UINavigationItem *navBarTopItem;
    UIBarButtonItem *doneButton = [[UIBarButtonItem alloc]initWithTitle:@"Cancelar"
                                                                  style:UIBarButtonItemStylePlain
                                                                 target:self action:nil];
    UINavigationBar *bar = navigationController.navigationBar;
    [bar setHidden:NO];
    navBarTopItem = bar.topItem;
    navBarTopItem.title = @"Fotos";
    navBarTopItem.rightBarButtonItem = doneButton;
}

- (IBAction)takePicture:(id)sender {
    UIImagePickerController *picker = [[UIImagePickerController alloc] init];
    
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary]) {
        picker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;

        picker.delegate = self;
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
            self.popover = [[UIPopoverController alloc] initWithContentViewController:picker];
            [self.popover presentPopoverFromRect:[sender bounds] inView:sender permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
        } else {
            [self presentViewController:picker animated:YES completion:nil];
        }
    }
    else {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"No hay librería de fotos" delegate:nil cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
        [alert show];
    }
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {
    self.image.image = (UIImage*)[info objectForKey:@"UIImagePickerControllerOriginalImage"];
    [self.presentedViewController dismissViewControllerAnimated:YES completion:nil];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Cancelado" message:@"Selección cancelada" delegate:nil cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
    [alert show];
    self.image.image = nil;
    [self.presentedViewController dismissViewControllerAnimated:YES completion:nil];
}

@end
