//
//  JSSItemView.h
//  Pintoresco
//
//  Created by jsainz on 08/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);

#import <UIKit/UIKit.h>

#import "JSSUtils.h"
#import "JSSStimulus.h"
#import "JSSRules.h"

#import "JSSMainView.h"
#import "JSSDataView.h"
#import "JSSInfoView.h"
#import "JSSTableView.h"

#import "JSSArrayShuffling.h"


@interface JSSItemView : UIViewController {
    NSString *fromInfo;
    NSMutableArray *itemUser;
    NSMutableArray *itemInfoUser;
    NSMutableArray *identifier;
    NSMutableArray *summary;
    
    NSMutableArray *recordFile;
    
    NSMutableArray *iLabels;
    NSMutableArray *labels;
    NSUserDefaults *defaults;
    
    NSString *userName;
    NSInteger series;
    NSInteger rule;
    
    NSNumber *idCard;
    NSString *name;
    NSString *surname;
    
    NSMutableArray *imageViews;
    NSMutableArray *images;
    UIImageView *itemImage;
    NSNumber *currentPage;
}

@property (nonatomic, strong) NSString *fromInfo;
@property (nonatomic, strong) NSMutableArray *itemUser;
@property (nonatomic, strong) NSMutableArray *itemInfoUser;
@property (nonatomic, strong) NSMutableArray *identifier;
@property (nonatomic, strong) NSMutableArray *summary;

@property (nonatomic, strong) NSMutableArray *recordFile;

@property (nonatomic, strong) NSMutableArray *iLabels;
@property (nonatomic, strong) NSMutableArray *labels;

@property NSInteger rule;
@property NSInteger series;

@property (nonatomic, strong) NSNumber *idCard;
@property (nonatomic, strong) NSString *userName;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *surname;


@property (nonatomic, retain) NSMutableArray *imageViews;
@property (nonatomic, retain) NSMutableArray *images;
@property (nonatomic, retain) IBOutlet UIImageView *itemImage;
@property (nonatomic, strong) NSNumber *currentPage;
    
- (void)button:(NSInteger)i time:(NSTimeInterval*)t;

- (void)startLearning;

- (void)onPrevious;

- (void)onNext;

- (void)onClose;

- (IBAction)saveData;



@end
