//
//  JSSItemView.m
//  Pintoresco
//
//  Created by jsainz on 08/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);
#define MAXTHUMBNAILS 4

#import "JSSItemView.h"
#import "JSSLearnView.h"

#import <mach/mach.h>

#define KEYIDCARD @"IdCard"
#define KEYUSER @"UserName"
#define KEYNAME @"Name"
#define KEYSURNAME @"Surname"
#define KEYRULE @"Rule"
#define KEYSERIES @"Series"
#define KEYPICTURE @"PictureCode"
#define KEYCATEGORY @"CategoryCode"

@interface JSSItemView () {
    NSMutableArray *inItem;
    NSMutableArray *outItem;
    NSMutableArray *buffer;
    NSMutableArray *infoData;
    BOOL imageSelected;
    
    NSDate *start;
    NSDate *finish;
    
    NSInteger block;
    
    NSInteger currentCountButtonCount;
    NSInteger countButtonCount;
    UIAlertView *alert;
    }

@property (nonatomic, strong) IBOutlet NSNumber *nSeries;
@property (nonatomic, strong) IBOutlet NSNumber *nRule;

- (void)writeFile:(NSMutableArray*)m title:(NSString*)fileName;

@end

@implementation JSSItemView

@synthesize nSeries;
@synthesize nRule;

@synthesize fromInfo;
@synthesize itemInfoUser;
@synthesize itemUser;
@synthesize identifier;
@synthesize summary;

@synthesize recordFile;

@synthesize iLabels;
@synthesize labels;

@synthesize rule, series;
@synthesize userName, name, surname, idCard;

@synthesize imageViews;
@synthesize images;
@synthesize itemImage;
@synthesize currentPage;

#pragma mark - Life cycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = @"APRENDIZAJE";
    }
    iLabels = [[NSMutableArray alloc]init];
    labels = [[NSMutableArray alloc]init];
    defaults = [[NSUserDefaults alloc]init];
    outItem = [[NSMutableArray alloc]init];

    return self;
}

- (id)initWithImages:(NSMutableArray *)someImages {
    self = [super init];
    if (self) {
        self.images = someImages;
        self.imageViews = [NSMutableArray array];
        currentPage = 0;
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setNavigationBar];
    
    // [self printOutInfo]; // Uncomment for printing out current info array
    // [self printOutItem]; // Uncomment for printing out current item array
    if (!(identifier == nil)) [self identify];
    if (!(summary == nil)) [self summarize];
    
    if (!(identifier == nil)) {userName = [identifier objectAtIndex:1];}
    if (!(identifier == nil)) {series = [[identifier objectAtIndex:7] intValue];}
    if (!(identifier == nil)) {rule = [[identifier objectAtIndex:8] intValue];}
    
    if (!(identifier == nil)) {NSLog(@"Usuario: %@", userName);}
    
    if (!(summary == nil)) {idCard = [summary objectAtIndex:5];}
    if (!(summary == nil)) {name = [summary objectAtIndex:6];}
    if (!(summary == nil)) {surname = [summary objectAtIndex:7];}
    if (!(summary == nil)) {series = [[summary objectAtIndex:28] intValue];}
    if (!(summary == nil)) {rule = [[summary objectAtIndex:29] intValue];}

    if (!(summary == nil)) {NSLog(@"Nombre: %@", name);}
    if (!(summary == nil)) {NSLog(@"Apellidos: %@", surname);}
    if (!(summary == nil)) {NSLog(@"Dni: %@", idCard);}
    
    if ((userName == NULL) && (surname == NULL))
        inItem = [self getItemFile];
    else
        inItem = [self saveItemFile:series rule:rule];
    
    JSSStimulus *dummy = [[JSSStimulus alloc]init];
    for (NSInteger i=0; i<(12*series); i++)
        [outItem addObject:dummy];
    recordFile = [[NSMutableArray alloc]init];
    recordFile = outItem;
    
    self.itemImage.image = [images objectAtIndex:0];
    [self setupThumbnailImageViews];
    [self setThumbnailsForPage:0];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)setNavigationBar {
    NSString *nameStr = [[NSString alloc]init];
    nameStr = @"TAREA";
    JSSUtils *bin = [[JSSUtils alloc]init];
    UIButton *button = [[UIButton alloc]init];
    button = [bin setNavigationBar:nameStr];
    [button addTarget:self action:@selector(BtnBackClick:) forControlEvents:UIControlEventTouchUpInside];
    
    //creates a UIBarButtonItem with the button as a custom view
    UIBarButtonItem *backButton = [[UIBarButtonItem alloc]initWithCustomView:button];
    [backButton setBackButtonTitlePositionAdjustment:UIOffsetMake(0.0, 0.0) forBarMetrics:UIBarMetricsDefault];
    [[self navigationItem]setLeftBarButtonItem:backButton];
    self.navigationItem.hidesBackButton = YES;
}

#pragma mark - Methods for moving back and forward to a View Controller

- (IBAction)BtnBackClick:(id)sender {
    JSSScrollView *scrollView = [[JSSScrollView alloc]init];
    [self.navigationController pushViewController:scrollView animated:YES];
}

#pragma mark - Methods to create and get stimulus patterns

- (NSMutableArray*)saveItemFile:(NSInteger)s rule:(NSInteger)r {
    NSLog(@"Series: %d Rule: %d %02d %02d", series, rule, identifier.count, summary.count);
    inItem = [self readPartition:rule]; // creates the series of exemplars of the given rule
    JSSStimulus *iArray = [[JSSStimulus alloc]init];
    NSMutableArray *media = [[NSMutableArray alloc]init];
    if (series == 0) series = 3;
    for (NSInteger s=0; s<series; s++) {
        [inItem shuffle];
        for (NSInteger i=0; i<inItem.count; i++) {
            iArray = [inItem objectAtIndex:i];
            if (iArray.category != 'N')
                [media addObject:iArray];
        }
    }
    return media;
}

- (NSMutableArray*)getItemFile {
    NSMutableArray *media = [[NSMutableArray alloc]init];
    NSMutableArray *pictures = [[NSMutableArray alloc]init];
    NSMutableArray *categories = [[NSMutableArray alloc]init];
    
    defaults = [NSUserDefaults standardUserDefaults];
    series = [defaults  integerForKey:@"KEYSERIES"];
    rule = [defaults integerForKey:@"KEYRULE"];
    
    NSLog(@"Series: %d Rule: %d %02d %02d", series, rule, identifier.count, summary.count);
    categories = [defaults objectForKey:@"KEYCATEGORY"];
    pictures = [defaults objectForKey:@"KEYPICTURE"];
    
    media = [[NSMutableArray alloc]init];
    for (NSInteger i=0; i<categories.count; i++) {
        NSString *catCode = [categories objectAtIndex:i];
        NSString *pictCode = [pictures objectAtIndex:i];
        NSString *str = [NSString stringWithFormat: @"%@ %@", catCode, pictCode];
        // Retrieves the previous series of exemplars of the given rule
        [media addObject:str];
    }
    
    JSSStimulus *oArray = [[JSSStimulus alloc]init];
    for (NSInteger i=0; i<media.count; i++) {
        // NSLog(@"check: %@", [media objectAtIndex:i]);
        
        oArray = [[JSSStimulus alloc]init];
        NSString *str = [media objectAtIndex:i];
        oArray.category = [str characterAtIndex:0];
        
        str = [str substringWithRange:NSMakeRange(2,5)];
        oArray.pictureCode = [str mutableCopy];
        
        NSLog(@"Item: %02i %c %@", i, oArray.category, oArray.pictureCode);
        [media replaceObjectAtIndex:i withObject:oArray];
    }
    return media;
}

- (NSMutableArray*)readPartition:(NSInteger)i {
    JSSRules *media = [[JSSRules alloc]init];
    inItem = [[NSMutableArray alloc]init];
    switch (i) {
        case 0:
            inItem = [media featureRule:inItem];
            break;
        case 1:
            inItem = [media equalRule:inItem];
            break;
        case 2:
            inItem = [media unEqualRule:inItem];
            break;
        default:
            inItem = [media exemplarRule:inItem];
            break;
    }
    return inItem;
}

#pragma mark - Experimental Task Methods

- (void) startLearning {
    defaults = [NSUserDefaults standardUserDefaults];
    
    nSeries = [NSNumber numberWithInteger:series];
    nRule = [NSNumber numberWithInteger:rule];
    
    NSInteger mySeries = [nSeries integerValue];
    NSInteger myRule = [nRule integerValue];
    
    [defaults setInteger:mySeries forKey:@"KEYSERIES"];
    [defaults setInteger:myRule forKey:@"KEYRULE"];
    
    if (!(identifier == nil))
        [defaults setObject:userName forKey:@"KEYUSERNAME"];
    
    if (!(summary == nil)) {
        [defaults setObject:idCard forKey:@"KEYIDCARD"];
        [defaults setObject:name forKey:@"KEYNAME"];
        [defaults setObject:surname forKey:@"KEYSURNAME"];
    }
    
    JSSStimulus *oArray = [[JSSStimulus alloc]init];
    NSMutableArray *pictureCodes = [[NSMutableArray alloc]init];
    for (int i = 0; i < inItem.count; i++) {
        oArray = [inItem objectAtIndex:i];
        [pictureCodes addObject:oArray.pictureCode];
    }
    NSMutableArray *categoryCodes = [[NSMutableArray alloc]init];
    for (int i = 0; i < inItem.count; i++) {
        oArray = [inItem objectAtIndex:i];
        NSString *string = [NSString stringWithFormat:@"%c" , oArray.category];
        [categoryCodes addObject:string];
    }
    
    [defaults setObject:pictureCodes forKey:@"KEYPICTURE"];
    [defaults setObject:categoryCodes forKey:@"KEYCATEGORY"];
    
    // NSLog(@"Series: %@ Rule: %@", [defaults objectForKey:@"KEYSERIES"], [defaults objectForKey:@"KEYRULE"]);
    
    [defaults synchronize]; // Call synchronize after set
    
    // Load all images from the bundle
    NSMutableArray *pictures = [NSMutableArray array];
    NSMutableString *iString = [[NSMutableString alloc]init];
    JSSUtils *utils = [[JSSUtils alloc]init];
    JSSStimulus *iArray = [[JSSStimulus alloc]init];
    for (int i = 0; i < inItem.count; i++) {
        iArray = [inItem objectAtIndex:i];
        // NSLog(@"Item  %02d: %c %@", i, iArray.category, iArray.pictureCode);
        
        iString = [NSMutableString stringWithFormat:@"%d", [iArray.pictureCode intValue]];
        iString = [utils stringPadding:iString length:4 string:@"0"];
        iString = [NSMutableString stringWithFormat:@"%@.png", iString];
        
        [pictures addObject:[UIImage imageNamed:[NSString stringWithFormat:@"%@", iString]]];
    }
    JSSItemView *pictureView = [[JSSItemView alloc] initWithImages:pictures];
    [self presentViewController:pictureView animated:YES completion: nil];
}

#pragma mark - Method for printing out subject's data

- (void)writeFile:(NSMutableArray*)m title:(NSString*)fileName {
    NSMutableString *oString = [[NSMutableString alloc]init];
    
    // NSString* filePath = @"~/Users/jsainz/Desktop/";
    NSString *filePath = @"/Users/Load/";
    [oString appendFormat:@"%@.txt", fileName];
    
    NSString* fileAtPath = [filePath stringByAppendingPathComponent:oString];
    if (![[NSFileManager defaultManager] fileExistsAtPath:fileAtPath])
        [[NSFileManager defaultManager] createFileAtPath:fileAtPath contents:nil attributes:nil];
    
    oString = [[NSMutableString alloc]init];
    for (NSString *var in m) {
        [oString appendFormat:@"%@ \n", var];
        [[oString dataUsingEncoding:NSUTF8StringEncoding] writeToFile:fileAtPath atomically:NO];
    }
}

- (void)printOutItem {
    if (!(fromInfo == nil)) {
        // NSLog(@"Received message: %@", fromInfo);
        NSMutableString *label = [[NSMutableString alloc]init];
        NSString *text = [[NSString alloc]init];
        NSMutableString *oString = [[NSMutableString alloc]init];
        
        JSSTableView *tableView = [[JSSTableView alloc]init];
        JSSUtils *bin = [[JSSUtils alloc] init];
        for (NSInteger i=1; i<itemInfoUser.count; i++) {
            label = [tableView doLabel:i];
            label = [bin stringPadding:label length:25 string:@" "];
            text = [itemInfoUser objectAtIndex:i];
            
            oString = label;
            [oString appendFormat:@"%@ ", text];
            NSLog(@"%@", oString);
        }
        NSLog(@"-----------------------------------");
    }
}

- (void)printOutInfo {
    if (!(fromInfo == nil)) {
        // NSLog(@"Received message: %@", fromInfo);
        NSMutableString *label = [[NSMutableString alloc]init];
        NSString *text = [[NSString alloc]init];
        NSMutableString *oString = [[NSMutableString alloc]init];
        
        JSSUtils *bin = [[JSSUtils alloc] init];
        JSSInfoView *infoView = [[JSSInfoView alloc]init];
        for (NSInteger i=1; i<itemUser.count; i++) {
            label = [infoView doLabel:i];
            label = [bin stringPadding:label length:25 string:@" "];
            text = [itemUser objectAtIndex:i];
            
            oString = label;
            [oString appendFormat:@"%@ ", text];
            NSLog(@"%@", oString);
        }
        NSLog(@"-----------------------------------");
    }
}

- (void)identify {
    NSMutableArray *identityFile = [[NSMutableArray alloc]init];
    NSMutableString *oString = [[NSMutableString alloc]init];
    NSString *iString = [[NSMutableString alloc]init];
    JSSUtils *bin = [[JSSUtils alloc] init];
    JSSMainView *labelMain = [[JSSMainView alloc]init];
    JSSTableView *labelTable = [[JSSTableView alloc]init];
    for (NSInteger i=0; i<5; i++)
        [iLabels addObject:[bin stringPadding:[labelMain doLabel:i] length:25 string:@" "]];
    for (NSInteger i=1; i<5; i++)
        [iLabels addObject:[bin stringPadding:[labelTable doLabel:i] length:25 string:@" "]];
    
    for (NSInteger i=1; i<itemInfoUser.count; i++) {
        [identifier addObject:[itemInfoUser objectAtIndex:i]];
    }
    // NSLog(@"Summary: %d", identifier.count);
    for (NSInteger i=1; i<iLabels.count; i++) {
        oString = [iLabels objectAtIndex:i];
        [oString appendFormat:@"%@", [identifier objectAtIndex:i]];
        NSLog(@"%@", oString);
        [identityFile addObject:oString];
    }
    oString = [[NSMutableString alloc]init];
    NSLog(@"identifier %d", identityFile.count);
    iString = [identifier objectAtIndex:1];
    [oString appendFormat:@"%@", iString];
    [self writeFile:identityFile title:oString];
}

- (void)summarize {
    NSMutableString *oString = [[NSMutableString alloc]init];
    NSString *iString = [[NSMutableString alloc]init];
    NSMutableArray *summaryFile = [[NSMutableArray alloc]init];
    JSSUtils *bin = [[JSSUtils alloc] init];
    JSSMainView *labelMain = [[JSSMainView alloc]init];
    JSSDataView *labelData = [[JSSDataView alloc]init];
    JSSInfoView *labelInfo = [[JSSInfoView alloc]init];
    JSSTableView *labelTable = [[JSSTableView alloc]init];
    for (NSInteger i=0; i<5; i++)
        [labels addObject:[bin stringPadding:[labelMain doLabel:i] length:25 string:@" "]];
    for (NSInteger i=1; i<13; i++)
        [labels addObject:[bin stringPadding:[labelData doLabel:i] length:25 string:@" "]];
    for (NSInteger i=1; i<10; i++)
        [labels addObject:[bin stringPadding:[labelInfo doLabel:i] length:25 string:@" "]];
    for (NSInteger i=1; i<5; i++)
        [labels addObject:[bin stringPadding:[labelTable doLabel:i] length:25 string:@" "]];
    
    for (NSInteger i=1; i<labels.count; i++) {
        oString = [labels objectAtIndex:i];
        [oString appendFormat:@"%@", [summary objectAtIndex:i]];
        NSLog(@"%@", oString);
        [summaryFile addObject:oString];
    }
    oString = [[NSMutableString alloc]init];
    iString = [summary objectAtIndex:6];
    [oString appendFormat:@"%@", iString];
    iString = [summary objectAtIndex:7];
    [oString appendFormat:@"%@", iString];
    [self writeFile:summaryFile title:oString];
}

#pragma mark - Interface Methods

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    UITouch *touch = [[event allTouches]anyObject];

    float height = ([[UIScreen mainScreen] bounds].size.height);
    float width = ([[UIScreen mainScreen] bounds].size.width);
    
    CGRect aRect = CGRectMake(width/3.7, height/1.64, 100.0f, 100.0f);
    CGRect bRect = CGRectMake(width/1.7, height/1.64, 100.0f, 100.0f);
    CGRect sRect = CGRectMake(width/10.6, height/9.48, 105.0f, 40.0f); // Start Button
    CGRect pRect = CGRectMake(width/3.7, height/9.48, 105.0f, 40.0f); // Previous Button
    CGRect nRect = CGRectMake(width/2.0, height/9.48, 105.0f, 40.0f); // Next Button
    CGRect cRect = CGRectMake(width/1.4, height/9.48, 105.0f, 40.0f); // Close Button

    if (imageSelected) {
        if ([self isTouch:touch WithinBoundsOf:&aRect]) {
            finish = [NSDate date];
            NSTimeInterval latency = [finish timeIntervalSinceDate:start];
            [self button:1 time:&latency];
        }
        else if([self isTouch:touch WithinBoundsOf:&bRect]) {
            finish = [NSDate date];
            NSTimeInterval latency = [finish timeIntervalSinceDate:start];
            [self button:2 time:&latency];
        }
    }
    if ([self isTouch:touch WithinBoundsOf:&sRect])
        [self startLearning];
    if ([self isTouch:touch WithinBoundsOf:&pRect])
        [self onPrevious];
    if ([self isTouch:touch WithinBoundsOf:&nRect])
        [self onNext];
    if ([self isTouch:touch WithinBoundsOf:&cRect])
        [self onClose];
}

- (BOOL)isTouch:(UITouch *)touch WithinBoundsOf:(CGRect *)rect {
    CGRect _frameRect = *rect;
    CGFloat _imageTop = _frameRect.origin.y;
    CGFloat _imageLeft = _frameRect.origin.x;
    CGFloat _imageRight = _frameRect.size.width+_imageLeft;
    CGFloat _imageBottom = _frameRect.size.height+_imageTop;
    
    CGPoint _touchPoint = [touch locationInView:self.view];
    // NSLog(@"click in %f %f", _touchPoint.x, _touchPoint.y);
    
    if ((_touchPoint.x >= _imageLeft) && (_touchPoint.x <= _imageRight) &&
        (_touchPoint.y >= _imageTop) && (_touchPoint.y <= _imageBottom))
        return YES;
    else
        return NO;
}

#pragma mark - Alert view management

- (void)fireAlert:(NSString*)message {
    
    JSSStimulus *oArray = [[JSSStimulus alloc]init];
    oArray = [buffer objectAtIndex:0];
    NSString *title = [NSString stringWithFormat:@"ENSAYO "];
    NSString *result = [title stringByAppendingString:[NSString stringWithFormat:@"%d", oArray.atIndex + 1]];

    alert = [[UIAlertView alloc] initWithTitle:message message:result
                                      delegate:nil cancelButtonTitle:nil otherButtonTitles:nil];
    [alert show];
    [self performSelector:@selector(test:) withObject:alert afterDelay:1.5];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    if (buttonIndex == 0) {
        NSLog(@"Activa una nueva serie");
    }
    if (buttonIndex == 1) {
        exit(0);
    }
}

- (void)endAlert:(NSString*)message {
    alert = [[UIAlertView alloc] initWithTitle:message message:@"PULSA INICIO" delegate:nil cancelButtonTitle:@"ACTIVA UNA SERIE NUEVA" otherButtonTitles:nil];
    [alert show];
    [self performSelector:@selector(test:) withObject:alert afterDelay:5];
}

-(void)test:(UIAlertView*)alarm{
    [alarm dismissWithClickedButtonIndex:-1 animated:YES];
}

#pragma mark - Methods for checking subject's responses

-(NSInteger)checkOutput:(NSInteger)s {
    NSInteger pending = 0;
    JSSStimulus *eArray = [[JSSStimulus alloc]init];
    for (NSInteger i=s; i<(12*series); i++) {
        eArray = [outItem objectAtIndex:i];
        if (eArray.latency < 0.001) pending++;
    }
    return pending;
}

- (void)button:(NSInteger)i time:(NSTimeInterval*)t {
    JSSStimulus *oArray = [[JSSStimulus alloc]init];
    oArray = [buffer objectAtIndex:0];
    NSInteger counter = [self checkOutput:0];
    
    if (counter > 0) {
        switch (i) {
            imageSelected = NO;
            case 1:
                if (oArray.category == 'A') {
                    [self fireAlert:@"CORRECTO"];
                    if (oArray.latency < 1) {
                        oArray.latency = *(t);
                        oArray.error = 0;
                        [outItem replaceObjectAtIndex:oArray.atIndex withObject:oArray];
                    }
                }
                else {
                    [self fireAlert:@"INCORRECTO"];
                    if (oArray.latency < 1) {
                        oArray.latency = *(t);
                        oArray.error = 1;
                        [outItem replaceObjectAtIndex:oArray.atIndex withObject:oArray];
                    }
                }
                break;
            case 2:
                if (oArray.category == 'B') {
                    [self fireAlert:@"CORRECTO"];
                    if (oArray.latency < 1) {
                        oArray.latency = *(t);
                        oArray.error = 0;
                        [outItem replaceObjectAtIndex:oArray.atIndex withObject:oArray];
                    }
                }
                else {
                    [self fireAlert:@"INCORRECTO"];
                    if (oArray.latency < 1) {
                        oArray.latency = *(t);
                        oArray.error = 1;
                        [outItem replaceObjectAtIndex:oArray.atIndex withObject:oArray];
                    }
                }
                break;
            default:
                break;
        }
    }
    else {
        NSInteger performance = [self checkOutput:25];
        if (performance > 0)
            [self endAlert:@"LA SERIE HA TERMINADO"];
        else
            [self endAlert:@"LA TAREA HA CONCLUIDO"];
    }
//    recordFile = outItem;
}

#pragma mark - Methods for select and move images

- (void)showSelectedImage:(UITapGestureRecognizer *)gestureRecognizer {
    
    start = [NSDate date];
    UIImageView *tappedImageView = (UIImageView *)[gestureRecognizer view];
    itemImage.image = tappedImageView.image;
    
    imageSelected = YES;
    JSSStimulus *oArray = [[JSSStimulus alloc]init];
    buffer = [[NSMutableArray alloc]init];
    for (NSInteger i=0; i<images.count; i++)
        if ([[images objectAtIndex:i] isEqual:itemImage.image]) {
            oArray = [inItem objectAtIndex:i];
            oArray.atIndex = i;
            // NSLog(@"Item: %02d %02d %02d %c %@", i, i/4, i%4, oArray.category, oArray.pictureCode);
            if ((i/4) == block) {
                [buffer addObject:oArray];
            }
        }
    oArray = [buffer objectAtIndex:0];
    /* NSLog(@"Item: %02d Block: %02d Position: %02d Cat: %c Picture: %@",
          oArray.atIndex, oArray.atIndex/4, oArray.atIndex%4, oArray.category, oArray.pictureCode);
    */
}

- (void)setupThumbnailImageViews {
    for (int i = 0; i < MAXTHUMBNAILS; i++) {
        UIImageView *imageView = [[UIImageView alloc] initWithFrame:
                                  CGRectMake(20.0,166.0+(130.0*i),90.0,90.0)];
    
        UITapGestureRecognizer *tapGestureRecognizer =
        [[UITapGestureRecognizer alloc] initWithTarget:self
                                                action:@selector(showSelectedImage:)];
        tapGestureRecognizer.numberOfTapsRequired = 1;
        tapGestureRecognizer.numberOfTouchesRequired = 1;
        [imageView addGestureRecognizer:tapGestureRecognizer];
    
        imageView.userInteractionEnabled = YES;
    
        itemImage.image = [UIImage imageNamed:[NSString stringWithFormat:@"black.png"]];

        [imageViews addObject:imageView];
        [self.view addSubview:imageView];
    }
}

- (void)setThumbnailsForPage:(int)aPage {
    for (int i = 0; i < MAXTHUMBNAILS; i++) {
        UIImageView *imageView = (UIImageView *)[imageViews objectAtIndex:i];
        UIImage *image = [self imageForIndex:aPage * MAXTHUMBNAILS + i];
        if (image) {
            imageView.image = image;
            imageView.hidden = NO;
            imageView.tag = i;
            block = aPage;
        }
        else
            imageView.hidden = YES;
    }
}

- (UIImage *)imageForIndex:(int)anIndex {
    if (anIndex < [images count])
        return [images objectAtIndex:anIndex];
    else
        return nil;
}

#pragma mark - User interface interaction

- (void)onPrevious {
    NSInteger nPage = [self.currentPage integerValue];
    if (nPage - 1 >= 0) {
        nPage--;
        [self setThumbnailsForPage:nPage];
    }
    self.currentPage = [NSNumber numberWithInt:nPage];
}

- (void)onNext {
    NSInteger nPage = [self.currentPage integerValue];
    if (nPage + 1 <= [images count] / MAXTHUMBNAILS) {
        nPage++;
        [self setThumbnailsForPage:nPage];
    }
    self.currentPage = [NSNumber numberWithInt:nPage];
}

- (void)onClose {
    itemImage.image = [UIImage imageNamed:[NSString stringWithFormat:@"black.png"]];
}

#pragma mark - Core Data stack

- (IBAction)saveData {
    
    JSSLearnView *learnView = [[JSSLearnView alloc] initWithNibName:@"JSSLearnView" bundle:nil];
    UINavigationController *navController = [[UINavigationController alloc] initWithRootViewController:learnView];
    
    learnView.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
    [self presentViewController:navController animated:YES completion:nil];
    
    learnView.learnInfoUser = itemInfoUser;
    learnView.learnUser = itemUser;
    learnView.itemFile = recordFile;
    
    if (!(identifier == nil) || !(summary == nil)) {
        learnView.identifier = identifier;
        learnView.summary = summary;
    }
}

@end
