//
//  JSSMainView.m
//  Pintoresco
//
//  Created by Javier Sainz on 05/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);

#import "JSSMainView.h"

@interface JSSMainView ()

- (IBAction)access:(id)sender;

@end

@implementation JSSMainView

@synthesize name;
@synthesize fromData;
@synthesize mainUser;
@synthesize mainInfoUser;
@synthesize summary;

#pragma mark - Life cycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
       self.title = @"ACCESO";
    }
    // Initializes the array which contains data collected from the subject
    mainInfoUser = [[NSMutableArray alloc]init];
    for (NSInteger i=0; i<5; i++)
        [mainInfoUser addObject:@""];
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // [self.navigationItem setTitle:@"ACCESO"];
    // self.view.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1]; //FFDEAD
    self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"Burners.png"]];
    
    // [self printOutMain]; // Activate for printing out current main array
    [self userData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

#pragma mark - Methods for printing out subject data

- (void)printOutMain {
    if (!(fromData == nil)) {
        NSLog(@"Received message: %@", fromData);
        
        JSSDataView *dataView = [[JSSDataView alloc]init];
        NSString *datum = [[NSString alloc]init];
        NSMutableString *label = [[NSMutableString alloc]init];
        JSSUtils *bin = [[JSSUtils alloc] init];
        for (NSInteger i=1; i<mainUser.count; i++) {
            label = [dataView doLabel:i];
            label = [bin stringPadding:label length:25 string:@" "];
            datum = [mainUser objectAtIndex:i];
            NSLog(@"%@ %@", label, datum);
        }
        NSLog(@"-----------------------------------");
    }
}

#pragma mark - Methods for moving back and forward to a View Controller

- (IBAction)access:(id)sender {
    JSSTableView *conditionsView = [[JSSTableView alloc]init];
    [self.navigationController pushViewController:conditionsView animated:YES];
    conditionsView.identifier = mainInfoUser;
}

- (IBAction)CollectData:(id)sender {
    JSSDataView *dataView = [[JSSDataView alloc]init];
    [self.navigationController pushViewController:dataView animated:YES];
    
    dataView.fromMain = @"Transferred Array";
    dataView.dataUser = mainInfoUser;
    
    for (NSInteger i=1; i<mainInfoUser.count; i++)
        [summary addObject:[mainInfoUser objectAtIndex:i]];
    dataView.summary = mainInfoUser;
}

#pragma mark - Methods for sending an email to the user

-(BOOL) NSStringIsValidEmail:(NSString *)checkString {
    BOOL stricterFilter = YES; // Discussion http://blog.logichigh.com/2010/09/02/validating-an-e-mail-address/
    NSString *stricterFilterString = @"[A-Z0-9a-z\\._%+-]+@([A-Za-z0-9-]+\\.)+[A-Za-z]{2,4}";
    NSString *laxString = @".+@([A-Za-z0-9]+\\.)+[A-Za-z]{2}[A-Za-z]*";
    NSString *emailRegex = stricterFilter ? stricterFilterString : laxString;
    NSPredicate *emailTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", emailRegex];
    return [emailTest evaluateWithObject:checkString];
}

-(void)mailComposeController:(MFMailComposeViewController*)controller
         didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error {
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (IBAction)SendMessage:(id)sender {
    MFMailComposeViewController *mc = [[MFMailComposeViewController alloc]init];
    if ([MFMailComposeViewController canSendMail]) {
        mc.mailComposeDelegate = self;
        [mc setSubject:@"Usuario y Contraseña"];

        NSString *media = [[NSString alloc]init];
        media = @"Usuario:";
        media = [media stringByAppendingString:[mainInfoUser objectAtIndex:1]];
        media = [media stringByAppendingString:@"\n Contraseña:"];
        media = [media stringByAppendingString:[mainInfoUser objectAtIndex:2]];
        media = [media stringByAppendingString:@"\n"];
        
        [mc setMessageBody:media isHTML:NO];

        BOOL OK = NO;
        if (!([[mainInfoUser objectAtIndex:0] isEqualToString:@""])) {
            NSString *string = ([mainInfoUser objectAtIndex:3]);
            if (![self NSStringIsValidEmail:string]) {
                [mc setToRecipients:[NSArray arrayWithObjects:string, nil]];
                OK = YES;
            }
            else
                OK = NO;
        }
        [self presentViewController:mc animated:YES completion:nil];
    }
    else
        NSLog(@"El dispositivo no permite enviar mensajes en este contexto");
}

#pragma mark - Methods for creating and controlling Text Fields

- (NSMutableString*)doLabel:(int)i {
    NSMutableString *label = [[NSMutableString alloc]init];
    switch (i) {
        case 1:
            label = [NSMutableString stringWithFormat:@"Usuario : "];
            break;
        case 2:
            label = [NSMutableString stringWithFormat:@"Contraseña : "];
            break;
        case 3:
            label = [NSMutableString stringWithFormat:@"eCorreo 1º : "];
            break;
        default:
            label = [NSMutableString stringWithFormat:@"eCorreo 2º : "];
            break;
    } //
    return label;
}

- (void)userData {
    
    float height = ([[UIScreen mainScreen] bounds].size.height);
    float width = ([[UIScreen mainScreen] bounds].size.width);
    
    // Creates a label to display current user interaction with our editable text views
    CGRect fstFrame = CGRectMake(width/3, height/9, 400, 30.0f);
    CGRect sndFrame = CGRectMake(width/2.5, height/3.5, 400, 30.0f);
    
    self.name = [[UILabel alloc] initWithFrame:fstFrame];
    self.name.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0f];
    self.name.textColor = [UIColor whiteColor];
    self.name.text = @"Introduce tus datos";
    self.name.textAlignment =  NSTextAlignmentCenter;
    [self.view addSubview:self.name];
    
    fstFrame = CGRectMake(width/1.9, height/9, 300, 30.0f);
    
    for (NSInteger i=1; i<5; i++) { // Creates the text field with that frame
        UITextField *textField = [[UITextField alloc]init];
        
        switch (i) {
            case 1:
            case 2:
                fstFrame.origin.y += fstFrame.size.height + 20.0f;
                textField = [[UITextField alloc] initWithFrame:fstFrame];
                break;
            default:
                sndFrame.origin.y += sndFrame.size.height + 30.0f;
                textField = [[UITextField alloc] initWithFrame:sndFrame];
                break;
        }
        textField.borderStyle = UITextBorderStyleRoundedRect;
        textField.textAlignment = NSTextAlignmentCenter;
        
        switch (i) {
            case 2:
                textField.secureTextEntry = !textField.secureTextEntry;
                break;
            case 3:
            case 4:
                textField.keyboardType = UIKeyboardTypeEmailAddress;
                break;
            default:
                textField.keyboardType = UIKeyboardTypeDefault;
                break;
        }
        // Displays hint for the user data entry when the field is empty
        NSString *textString = [[NSString alloc]init];
        textString = [self doLabel:i];
        
        textField.placeholder = [NSString stringWithFormat:@"Introduce datos de %@", textString];
        
        // Add tag to identify your text views
        textField.tag = i;
        // Displays the clear button on the text field
        textField.clearButtonMode = UITextFieldViewModeAlways;
        // Changes the return key text to "Done"
        textField.returnKeyType = UIReturnKeyDone;
        
        // Sets the delegate for the text field to the view controller
        textField.delegate = self;
        // Adds the text field to the current view
        [self.view addSubview:textField];
        
//        NSManagedObjectContext *context = [[NSManagedObjectContext alloc]init];
//        JSSIdentity *person = [NSEntityDescription
//                insertNewObjectForEntityForName:@"Persona" inManagedObjectContext:context];
//        person.name = @"Joaquin";
        // [context deleteObject:person];
    }
}

// Asks the delegate if editing should begin in the specified text field.
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField {
    return YES;
}

// Tells the delegate that editing began for the specified text field.
- (void)textFieldDidBeginEditing:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSString *textString = [[NSString alloc]init];
    textString = [self doLabel:i];
    self.name.text = [NSString stringWithFormat:@"Escritura de %@", textString];
}

// Asks the delegate if editing should stop in the specified text field.
- (BOOL)textFieldShouldEndEditing:(UITextField *)textField{
    return YES;
}

// Tells the delegate that editing stopped for the specified text field.
- (void)textFieldDidEndEditing:(UITextField *)textField {
    NSInteger i = textField.tag;
    
    NSMutableString *textString = [[NSMutableString alloc]init];
    textString = [self doLabel:i];
    self.name.text = [NSString stringWithFormat:@"Datos de %@", textString];

    // NSLog(@"Registering... %i %@", i, textField.text);
    [mainInfoUser replaceObjectAtIndex:i withObject:textField.text];
    
    JSSItemView *data = [[JSSItemView alloc]init];
    [data.summary replaceObjectAtIndex:i withObject:textField.text];
}

// Asks the delegate if the specified text should be changed.
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range
                                                       replacementString:(NSString *)string {
    
    //get the current data strsing inside the text field
    NSString *textData = [textField.text stringByReplacingCharactersInRange:range
                                                                   withString:string];
    NSInteger i = textField.tag;
    switch (i) {
        default: //don't allow more than a given number of characters
            if ([textData length] > 25)
                return NO;
            break;
    }
    // set the display label value with the current data in the text field
    // self.label.text = [NSString stringWithFormat:@"Datos: %@", textData];
    return YES;
}

// Asks the delegate if the text field’s current contents should be removed.
- (BOOL)textFieldShouldClear:(UITextField *)textField {
    NSInteger i = textField.tag;
    NSLog(@"Borrado de datos de %i", i);
    return YES;
}

// Asks the delegate if the text field should process the pressing of the return button.
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    // Notifies the receiver that it has been asked to relinquish its status as first responder
    [textField resignFirstResponder];
    return YES;
}

@end
