//
//  JSSScrollView.m
//  Pintoresco
//
//  Created by jsainz on 08/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);

#import "JSSScrollView.h"

@interface JSSScrollView ()

@end

@implementation JSSScrollView

@synthesize webView;
@synthesize fromInfo;
@synthesize scrollInfoUser;
@synthesize scrollUser;
@synthesize identifier;
@synthesize summary;

#pragma mark - Life cycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = @"INSTRUCCIONES";
        self.view.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1]; //FFDEAD
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self setNavigationBar];
    NSString *path = @"Pintoresco-10/Pintoresco/text.htm";
    NSBundle *thisBundle = [NSBundle mainBundle];
    path = [thisBundle pathForResource:@"text" ofType:@"html"];
    
    NSString *htmlFile = [[NSBundle mainBundle] pathForResource:@"text" ofType:@"htm"];
    NSString *htmlString = [NSString stringWithContentsOfFile:htmlFile encoding:NSUTF8StringEncoding error:nil];
    [webView loadHTMLString:htmlString baseURL:nil];
}

- (void)viewDidAppear:(BOOL)animated {
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)setNavigationBar {
    NSString *nameStr = [[NSString alloc]init];
    nameStr = @"CASOS";
    JSSUtils *bin = [[JSSUtils alloc]init];
    UIButton *button = [[UIButton alloc]init];
    button = [bin setNavigationBar:nameStr];
    [button addTarget:self action:@selector(BtnBackClick:) forControlEvents:UIControlEventTouchUpInside];
    
    //creates a UIBarButtonItem with the button as a custom view
    UIBarButtonItem *backButton = [[UIBarButtonItem alloc]initWithCustomView:button];
    [backButton setBackButtonTitlePositionAdjustment:UIOffsetMake(0.0, 0.0) forBarMetrics:UIBarMetricsDefault];
    [[self navigationItem]setLeftBarButtonItem:backButton];
    self.navigationItem.hidesBackButton = YES;
}

#pragma mark - Methods for moving back and forward to a View Controller

- (IBAction)BtnBackClick:(id)sender {
    JSSTableView *tableView = [[JSSTableView alloc]init];
    [self.navigationController pushViewController:tableView animated:YES];
}

- (IBAction)pressStart:(id)sender {
    JSSItemView *itemView = [[JSSItemView alloc]init];
    [self.navigationController pushViewController:itemView animated:YES];
    
    itemView.fromInfo = fromInfo;
    itemView.itemInfoUser = scrollInfoUser;
    itemView.itemUser = scrollUser;
    
    if (!(identifier == nil) || !(summary == nil)) {
        itemView.identifier = identifier;
        itemView.summary = summary;
    }
}

@end
