//
//  JSSTableView.m
//  Pintoresco
//
//  Created by jsainz on 07/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);
#define ONLYNUMBERS @"1234567"

#import "JSSTableView.h"

static NSString *CellIdentifier = @"Cell";

@interface JSSTableView ()

@end

@implementation JSSTableView

@synthesize tableViewController;

@synthesize aNumCat;
@synthesize bNumCat;
@synthesize seriesNum;

@synthesize fromInfo;
@synthesize tableUser;
@synthesize tableInfoUser;
@synthesize identifier;
@synthesize summary;

@synthesize selection;
@synthesize tableView;

#pragma mark - Life cycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = @"CONDICIONES";
        self.view.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1]; //FFDEAD
    }
    // Initializes the array which contains data collected from the subject
    tableInfoUser = [[NSMutableArray alloc]init];
    for (NSInteger i=0; i<5; i++) {
        [tableInfoUser addObject:@""];
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];

    tableViewController = [[UITableViewController alloc] initWithStyle:tableView.style];
    tableViewController.tableView = tableView;
    [self addChildViewController:tableViewController];
    [self setNavigationBar];
    // Do any additional setup after loading the view from its nib.
    [self.tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:CellIdentifier];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)setNavigationBar {
    NSString *nameStr = [[NSString alloc]init];
    nameStr = @"INFOS";
    JSSUtils *bin = [[JSSUtils alloc]init];
    UIButton *button = [[UIButton alloc]init];
    button = [bin setNavigationBar:nameStr];
    [button addTarget:self action:@selector(BtnBackClick:) forControlEvents:UIControlEventTouchUpInside];
    
    //creates a UIBarButtonItem with the button as a custom view
    UIBarButtonItem *backButton = [[UIBarButtonItem alloc]initWithCustomView:button];
    [backButton setBackButtonTitlePositionAdjustment:UIOffsetMake(0.0, 0.0) forBarMetrics:UIBarMetricsDefault];
    [[self navigationItem]setLeftBarButtonItem:backButton];
    self.navigationItem.hidesBackButton = YES;
}

#pragma mark - Methods for moving back and forward to a View Controller

- (IBAction)BtnBackClick:(id)sender {
    JSSInfoView *infoView = [[JSSInfoView alloc]init];
    [self.navigationController pushViewController:infoView animated:YES];
}

- (IBAction)doInfo:(id)sender {
    JSSScrollView *scrollView = [[JSSScrollView alloc]init];
    [self.navigationController pushViewController:scrollView animated:YES];
    if (!(selection == nil)) 
        [tableInfoUser replaceObjectAtIndex:4 withObject:selection];

    scrollView.identifier = identifier;
    
    scrollView.fromInfo = fromInfo;
    scrollView.scrollInfoUser = tableInfoUser;
    scrollView.scrollUser = tableUser;
    
    for (NSInteger i=1; i<tableInfoUser.count; i++)
        [summary addObject:[tableInfoUser objectAtIndex:i]];
    scrollView.summary = summary;
}

- (NSMutableString*)doLabel:(int)i {
    NSMutableString *label = [[NSMutableString alloc]init];
    switch (i) {
        case 1:
            label = [NSMutableString stringWithFormat:@"Clase A : "];
            break;
        case 2:
            label = [NSMutableString stringWithFormat:@"Clase B : "];
            break;
        case 3:
            label = [NSMutableString stringWithFormat:@"Series : "];
            break;
        default:
            label = [NSMutableString stringWithFormat:@"Selección : "];
            break;
    } //
    return label;
}

#pragma mark - TextField management

- (BOOL)textField:(UITextField *)textField
    shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    
    NSUInteger limit = [textField.text length] + [string length] - range.length;
    NSCharacterSet *charSet = [[NSCharacterSet characterSetWithCharactersInString:ONLYNUMBERS]invertedSet];
    NSString *filtered = [[string componentsSeparatedByCharactersInSet:charSet]componentsJoinedByString:@""];
    return (([string isEqualToString:filtered]) && (limit <= 1));
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    aNumCat.tag = 1; bNumCat.tag = 2; seriesNum.tag = 3;
    // Number of exemplars for A-category: Default 7 -not yet implemented for other options
    // [tableInfoUser replaceObjectAtIndex:1 withObject:aNumCat.text];
    [tableInfoUser replaceObjectAtIndex:1 withObject:@"7"];
    // Number of exemplars for B-category: Default 5 -not yet implemented for other options
    // [tableInfoUser replaceObjectAtIndex:2 withObject:bNumCat.text];
    [tableInfoUser replaceObjectAtIndex:2 withObject:@"5"];
    [tableInfoUser replaceObjectAtIndex:3 withObject:seriesNum.text];
    return YES;
}

#pragma mark - UITableView Delegate/Datasource

- (void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath {
    cell.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1];
}

// Determines the number of sections within this table view
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1; // Returns the number of sections
}

// Determines the number of rows for the argument section number
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 4; // Returns the number of rows in the section.
}

// Returns cell identified by the argument indexPath
- (UITableViewCell *)tableView:(UITableView *)tView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    if (cell == nil) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    switch ((indexPath.row)) {
        case 0:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición de Rasgo"];
            cell.imageView.image = [UIImage imageNamed:@"Feature.png"];
            break;
        case 1:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición Idéntica"];
            cell.imageView.image = [UIImage imageNamed:@"Equal.png"];
            break;
        case 2:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición Desigual"];
            cell.imageView.image = [UIImage imageNamed:@"Unequal.png"];
            break;
        case 3:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición Ejemplar"];
            cell.imageView.image = [UIImage imageNamed:@"Exemplar.png"];
            break;
        default:
            break;
    }
    return cell;
}

// Call the cell touch handler and pass in the cell associated with the argument section/row
- (void)tableView:(UITableView *)tView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    NSString *info = [[NSString alloc]init];
    UIAlertView *alert = [[UIAlertView alloc]init];
    if (cell == nil) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    switch ((indexPath.row)) {
        case 0:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición de Rasgo"];
            cell.imageView.image = [UIImage imageNamed:@"Feature.png"];
            info = [NSString stringWithFormat:@"Has elegido la Condición de Rasgo"];
            break;
        case 1:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición Idéntica"];
            cell.imageView.image = [UIImage imageNamed:@"Equal.png"];
            info = [NSString stringWithFormat:@"Has elegido la Condición Idéntica"];
            break;
        case 2:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición Desigual"];
            cell.imageView.image = [UIImage imageNamed:@"Unequal.png"];
            info = [NSString stringWithFormat:@"Has elegido la Condición Desigual"];
            break;
        case 3:
            cell.textLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:17.0];
            cell.textLabel.text = [NSString stringWithFormat:@"     Condición Ejemplar"];
            cell.imageView.image = [UIImage imageNamed:@"Exemplar.png"];
            info = [NSString stringWithFormat:@"Has elegido la Condición Ejemplar"];
            break;
        default:
            break;
    }
    // self.alertView.backgroundColor = [UIColor colorWithRed:1 green:0.871 blue:0.678 alpha:1]; //FFDEAD
    
    alert = [[UIAlertView alloc]initWithTitle:@"Información" message:info delegate:nil
                            cancelButtonTitle:@"Aceptar" otherButtonTitles:nil];
    [alert show];
    [self performSelector:@selector(test:) withObject:alert afterDelay:2];
    
    NSString *intermediary = [[NSString alloc]init];
    intermediary = [NSString stringWithFormat:@"%d",indexPath.row];
    selection = intermediary;
}

#pragma mark - Alert view management

-(void)test:(UIAlertView*)alarm{
    [alarm dismissWithClickedButtonIndex:-1 animated:YES];
}

- (void)willPresentAlertView:(UIAlertView *)alertView {
    [self.tableView deselectRowAtIndexPath:self.tableView.indexPathForSelectedRow animated:YES];
}

@end
