//
//  JSSStimulus.m
//  Pintoresco
//
//  Created by jsainz on 11/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);

static NSInteger(MAXITEMS) = 16;

#import "JSSStimulus.h"
#import "JSSUtils.h"

#pragma mark - Stimulus Class

// Creates a Stimulus Set
@implementation JSSStimulus

@synthesize atIndex;
@synthesize category, pictureCode;
@synthesize test;
@synthesize nItem, latency, error;

+ (JSSStimulus*) aStimulus {
    return [[JSSStimulus alloc] init];
}

- (id) initStimulus: (char)i picture: (NSMutableString*)j {
    self = [super init];
    if (self != nil) {
        category = i;
        pictureCode = j;
    }
    return self;
}

- (NSMutableArray*)arrayOfItems {
    JSSStimulus *iArray = [[JSSStimulus alloc] init];
    NSMutableArray *item = [[NSMutableArray alloc] init];
    NSMutableString *binString = [[NSMutableString alloc]init];
    
    NSInteger k;
    JSSUtils *bin = [[JSSUtils alloc]init];
    for (NSInteger i=0; i<MAXITEMS; i++) {
        binString = [bin decimalToBinary:&i];
        binString = [bin stringPadding:binString length:5 string:@"0"];
        // NSLog(@"Cadena regular: %@", bString);
        
        k = [bin assignNum:65 limit:67];
        iArray = [[JSSStimulus alloc] init];
        iArray = [iArray initStimulus: (char)k
                              picture: [NSMutableString stringWithString:binString]];
        [item addObject:iArray];
    }
    return item;
}

- (void)itemToString:(NSMutableArray*)item {
    NSString *sCat, *sPicCode = [[NSString alloc] init];
    NSString *result = [[NSString alloc] init];
    for (NSInteger i=0; i<item.count; i++) {
        JSSStimulus *str = [item objectAtIndex: i];
        // NSLog(@"%hhd %@ %@", str.category, str.pictureCode, [str.condition componentsJoinedByString:@" "]);
        
        sCat = [NSString stringWithFormat:@"%c", str.category];
        sPicCode = str.pictureCode;
        
        result = [result stringByAppendingString:sCat];
        result = [result stringByAppendingString:sPicCode];
        result = [result stringByAppendingString:@","];
        // NSLog(@"Result string: %@", result);
        [str writeStringToFile:result];
    }
}

/* */
- (void)writeStringToFile:(NSString*)aString {
    //  NSString* filePath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    
    // NSString* filePath = @"/Users/jsainz/Desktop/";
    NSString* filePath = @"/Users/Load/";
    NSString* fileName = @"Particion.txt";
    NSString* fileAtPath = [filePath stringByAppendingPathComponent:fileName];
    if (![[NSFileManager defaultManager] fileExistsAtPath:fileAtPath]) {
        [[NSFileManager defaultManager] createFileAtPath:fileAtPath contents:nil attributes:nil];
    }
    [[aString dataUsingEncoding:NSUTF8StringEncoding] writeToFile:fileAtPath atomically:NO];
}

/* */
- (NSString*)readStringFromFile {
    //  NSString* filePath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    NSString* filePath = @"/Users/jsainz/Desktop/";
    NSString* fileName = @"Particion.txt";
    NSString* fileAtPath = [filePath stringByAppendingPathComponent:fileName];
    
    return [[NSString alloc] initWithData:[NSData dataWithContentsOfFile:fileAtPath] encoding:NSUTF8StringEncoding];
}

@end

#pragma mark - Migration Class

/* Series of 4 stimulus patterns from category A/B */
@implementation JSSMigration

@synthesize mSeries;

+ (JSSMigration*) aStimulus {
    return [[JSSMigration alloc] init];
}

- (id) initWithName: (char)aCategory : (NSMutableString*)aPictureCode {
    self = [super init];
    if (self != nil) {
        category = aCategory;
        pictureCode = aPictureCode;
    }
    return self;
}

// creates migration sets of stimuli
- (NSMutableArray*)createMigrations{
    NSMutableString *aux = [[NSMutableString alloc]init];
    NSString *str = [[NSMutableString alloc]init];
    
    JSSMigration *migration = [[JSSMigration alloc]init];
    NSMutableArray *inItem = [[NSMutableArray alloc] init];
    JSSStimulus *inArray = [[JSSStimulus alloc]init];
    inItem = [inArray arrayOfItems];
    NSMutableArray *series = [[NSMutableArray alloc] initWithObjects:nil];
    self.mSeries = [NSMutableArray arrayWithCapacity:48];
    
    NSInteger k;
    JSSUtils *bin = [[JSSUtils alloc]init];
    // NSLog(@"#inItem.count: %02d",inItem.count);
    for (NSInteger i=0; i<inItem.count; i++) {
        inArray = [inItem objectAtIndex:i];
        // NSLog(@"Series number: %02d %hhd %@", i, inArray.category, inArray.pictureCode);
        
        migration = [[JSSMigration alloc] init];
        k = [bin assignNum:65 limit:67];
        
        inArray = [migration initStimulus:k picture:inArray.pictureCode];
        
        NSMutableString *media = [NSMutableString stringWithString:inArray.pictureCode];
        [series addObject:media];
        for (NSInteger j=1; j<4; j++) {
            NSInteger thres;
            NSInteger n = j;
            
            inArray = [inItem objectAtIndex:i];
            aux = inArray.pictureCode;
            
            for (NSInteger k=1; k<5; k++) { // array of codes for stimulus coding
                if ((n-j) / 2) // odd
                    thres = n - 2;
                else // even: not(odd(n -1) / 2)
                    thres = n;
                // NSLog(@"%s", (n-j) & 1 ? "odd" : "even");
                if (k == thres) {
                    str = [[aux substringFromIndex:k]substringToIndex:1];
                    if ([str isEqual: @"1"])
                        [aux replaceCharactersInRange: NSMakeRange(k, 1) withString: @"0"];
                    else
                        [aux replaceCharactersInRange: NSMakeRange(k, 1) withString: @"1"];
                } // if (k == thres)
            } // for (NSInteger k=1; k<5; k++)
            
            // migration = [[Migration alloc] init];
            // [migration initStimulus:'B' picture:aux];
            
            NSMutableString *media = [NSMutableString stringWithString:migration.pictureCode];
            [series addObject:media];// reference model no added: result 48 stimulus patterns
            NSLog(@"%02d %c %@", n, migration.category, migration.pictureCode);
            n++;
        } // for (NSInteger j=1; j<4; j++) // 3 series of 4 patterns
    } // for (NSInteger i=0; i<inItem.count; i++)
    
    // [self.migrationSeries replaceObjectAtIndex:i withObject:temp];
    for (NSInteger i=0; i<3; i++){
        for (NSInteger j=0; j<series.count; j++){
            JSSMigration *temp = [[JSSMigration alloc]init];
            temp.category = 'B';
            temp.pictureCode = [series objectAtIndex:j];
            [self.mSeries addObject:temp];
        }
    }
    return self.mSeries;
}

@end
