//
//  JSSArrayShuffling.m
//  Pintoresco
//
//  Created by jsainz on 26/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

#import "JSSArrayShuffling.h"

@implementation NSMutableArray (Shuffling)

- (void)shuffle {
    static BOOL seed = NO;
    if (!seed) {
        seed = YES;
        srandom(time(NULL));
    }
    NSUInteger count = [self count];
    for (NSUInteger i=0; i<count; ++i) {
        // Select a random element between i and end of array to swap with
        int nElements = count - i;
        int n = (random() % nElements) + i;
        [self exchangeObjectAtIndex:i withObjectAtIndex:n];
    }
}

@end