//
//  JSSUtils.m
//  Pintoresco
//
//  Created by jsainz on 11/11/13.
//  Copyright (c) 2013 Javier Sainz. All rights reserved.
//

static NSInteger(MAXITEMS) = 16;

#define NSLog(FORMAT, ...) printf("%s\n", [[NSString stringWithFormat:FORMAT, ##__VA_ARGS__] UTF8String]);
#import "JSSUtils.h"
#import "JSSStimulus.h"

#pragma mark - Utilities Class

@implementation JSSUtils

- (NSMutableString*)decimalToHex:(NSInteger*)any{
    NSMutableString *iString = [[NSMutableString alloc]init];
    for (NSInteger i=0; i<MAXITEMS; i++)
        iString = [NSMutableString stringWithFormat:@"%x", i];
    return iString;
}

- (NSMutableString*)decimalToBinary:(NSInteger*)any {
    NSMutableString *iString = [[NSMutableString alloc]init];
    // Prepend "0" or "1", depending on the bit
    for(NSInteger numberCopy = *any; numberCopy > 0; numberCopy >>= 1) {
        [iString insertString:((numberCopy & 1) ? @"1" : @"0") atIndex:0];
    }
    return iString;
}

- (NSMutableString*)stringPadding:(NSMutableString*)s length:(NSInteger)n string:(NSString*)str {
    NSMutableString *iString = [[NSMutableString alloc]init];
    NSString *intermediary = [[NSString alloc] init];
    for(NSInteger i = 0; i < (n - s.length); i++)
        intermediary = [intermediary stringByAppendingString:str];
    return iString = [NSMutableString stringWithString:[intermediary stringByAppendingString:s]];
}

- (int)assignNum:(int)low limit:(int)upper {
    int rndValue = low + arc4random() % (upper - low);
    return rndValue;
}

// Sets member category
- (NSMutableArray*)setCat:(NSMutableArray*)item aMembers:(int)aM bMembers:(int)bM {
    JSSStimulus *iArray = [[JSSStimulus alloc] init];
    item = [iArray arrayOfItems]; //
    NSInteger a = 0;
    NSInteger b = 0;
    BOOL OK = NO;
    JSSUtils *bin = [[JSSUtils alloc]init];
    do {
        for (NSInteger i=0; i<item.count; i++) {
            iArray = [item objectAtIndex:i];
            iArray.category = [bin assignNum:65 limit:67];
        }
        a = [self numOfCat:item label:'A'];
        b = [self numOfCat:item label:'B'];
        
        if ((a >= 7) && (b >= 5))
            OK = YES;
    } while (!OK);
    // NSLog(@"A: %d B: %d", a, b);
    return item;
}

- (NSInteger)numOfCat:(NSMutableArray*)s label:(char)cat{
    NSInteger c = 0;
    JSSMigration *temp = [[JSSMigration alloc]init];
    for (NSInteger j=0; j<s.count; j++){
        temp = [s objectAtIndex:j];
        if (temp.category == (char)cat)
            c++;
    }
    return c;
}

- (void)checkCodes:(NSMutableDictionary*)dictionary imageArray:(NSArray*)img item:(UIImageView*)picture {
    NSArray *keys = [dictionary allKeys]; // NSMutableDictionary: order other than NSArray
    for (NSInteger i = 0; i < 16; i++) {
        picture.image = [img objectAtIndex:i];
        NSLog(@"Code: %@", picture.image.description);
        id aKey = [keys objectAtIndex:i];
        id anObject = [dictionary objectForKey:aKey];
        NSLog(@"Key/Object: %@ %@", aKey, anObject);
        if ([aKey isEqual:@"1111.png"])
            NSLog(@"Object found: %d %@ %@ %@", i, aKey, anObject, picture);
    } 
}

- (UIImage *)imageByScalingProportionallyToSize:(CGSize)targetSize source:(NSString*)str {
    UIImage *sourceImage = [UIImage imageNamed:@"Logo.png"];
    UIImage *newImage = nil;
    
    CGSize imageSize = sourceImage.size;
    CGFloat width = imageSize.width;
    CGFloat height = imageSize.height;
    
    CGFloat targetWidth = targetSize.width;
    CGFloat targetHeight = targetSize.height;
    
    CGFloat scaleFactor = 0.0;
    CGFloat scaledWidth = targetWidth;
    CGFloat scaledHeight = targetHeight;
    
    CGPoint thumbnailPoint = CGPointMake(0.0,0.0);
    
    if (!CGSizeEqualToSize(imageSize, targetSize)) {
        CGFloat widthFactor = targetWidth / width;
        CGFloat heightFactor = targetHeight / height;
        
        if (widthFactor < heightFactor)
            scaleFactor = widthFactor;
        else
            scaleFactor = heightFactor;
        
        scaledWidth  = width * scaleFactor;
        scaledHeight = height * scaleFactor;
        
        // Centers the image
        if (widthFactor < heightFactor) {
            thumbnailPoint.y = (targetHeight - scaledHeight) * 0.5;
        }
        else if (widthFactor > heightFactor) {
            thumbnailPoint.x = (targetWidth - scaledWidth) * 0.5;
        }
    }
    // Routine that performs the procedure
    UIGraphicsBeginImageContext(targetSize);
    
    CGRect thumbnailRect = CGRectZero;
    thumbnailRect.origin = thumbnailPoint;
    thumbnailRect.size.width  = scaledWidth;
    thumbnailRect.size.height = scaledHeight;
    
    [sourceImage drawInRect:thumbnailRect];
    newImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    if(newImage == nil) NSLog(@"could not scale image");
    return newImage ;
}

    // creates a UIBarButtonItem with the button as a custom view
- (UIButton*)setNavigationBar:(NSString*)nameStr {
    
    UIImage *image = [UIImage imageNamed:@"Logo.png"];
    image = [self imageByScalingProportionallyToSize:CGSizeMake(50.0, 50.0) source:@"Logo.png"];
    // NSLog(@"image width %f %f", image.size.width, image.size.height);
    
    CGSize textSize = [nameStr sizeWithAttributes:@{NSFontAttributeName:[UIFont
                                     fontWithName:@"Arial Rounded MT Bold" size:14]}];
    
    // NSLog(@"text width %f %f", textSize.width, textSize.height);
    
    CGSize buttonSize = CGSizeMake(textSize.width * 3.0f, image.size.width);
    // NSLog(@"button width %f %f", buttonSize.width, buttonSize.height);
    
    UIButton *button = [[UIButton alloc]init];
    [button setFrame:CGRectMake(0.0f, 0.0f, buttonSize.width, buttonSize.height)];
    
    [button setTitle:nameStr forState:UIControlStateNormal];
    button.titleLabel.font = [UIFont fontWithName:@"Arial Rounded MT Bold" size:14.0];
    [button setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    
    // [button setBackgroundImage:image forState:UIControlStateNormal]; // To overimposed image and title
    [button setImage:image forState:UIControlStateNormal];
    button.adjustsImageWhenDisabled = YES;
    
    
//    [button addTarget:self action:@selector(BtnBackClick:) forControlEvents:UIControlEventTouchUpInside];
//    
//    //creates a UIBarButtonItem with the button as a custom view
//    UIBarButtonItem *backButton = [[UIBarButtonItem alloc]initWithCustomView:button];
//    // [backButton setBackButtonTitlePositionAdjustment:UIOffsetMake(0.0, 0.0) forBarMetrics:UIBarMetricsDefault];
    return button;
}

@end


